SystemOrganization addCategory: #'XMI-Analyzer'!
SystemOrganization addCategory: 'XMI-Analyzer-Core'!
SystemOrganization addCategory: 'XMI-Analyzer-Tests'!
SystemOrganization addCategory: 'XMI-Analyzer-Utility'!

XMLNodeVisitor subclass: #XAAbstractGeneratingVisitor
	instanceVariableNames: 'generator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Core'!

!XAAbstractGeneratingVisitor methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
classPrefix: aString
	generator classPrefix: aString! !

!XAAbstractGeneratingVisitor methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
generatorClass
	^ self subclassResponsibility! !

!XAAbstractGeneratingVisitor methodsFor: 'initialization' stamp: ' 6/23/2016 16:38:24'!
initialize
	super initialize.
	generator := self generatorClass new! !

!XAAbstractGeneratingVisitor methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
packageName: aPackageName
	generator packageName: aPackageName
	! !

!XAAbstractGeneratingVisitor methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
useTypeNamespace: aBoolean
	"XMI often has namespaces in types, e.g. <subvertex xmi:type='uml:State' xmi:id='ID_1'>.
	true -> use 'uml:State' as type
	false -> use 'State' as type"

	generator useTypeNamespace: aBoolean! !

XAAbstractGeneratingVisitor subclass: #XACodeGeneratingVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Core'!

!XACodeGeneratingVisitor methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
generatorClass
	^ XAClassStructureGenerator! !

!XACodeGeneratingVisitor methodsFor: 'visiting' stamp: ' 6/23/2016 16:38:24'!
visitDocument: aDocument
	super visitDocument: aDocument.
	generator createClassesInSystem! !

!XACodeGeneratingVisitor methodsFor: 'visiting' stamp: ' 6/23/2016 16:38:24'!
visitElement: anElement
	(anElement name beginsWith: 'xmi:')
		ifFalse: [ generator processElement: anElement ].
	^ super visitElement: anElement! !

XAAbstractGeneratingVisitor subclass: #XAInstanceGeneratingVisitor
	instanceVariableNames: 'instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Core'!

!XAInstanceGeneratingVisitor methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
generator
	^ generator! !

!XAInstanceGeneratingVisitor methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
generator: aGenerator
	generator := aGenerator! !

!XAInstanceGeneratingVisitor methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
generatorClass
	^ XAObjectInstanceGenerator! !

!XAInstanceGeneratingVisitor methodsFor: 'visiting' stamp: ' 6/23/2016 16:38:24'!
visit: aDocument
	super visit: aDocument.
	^ instance! !

!XAInstanceGeneratingVisitor methodsFor: 'visiting' stamp: ' 6/23/2016 16:38:24'!
visitDocument: aDocument
	generator inferTypesIn: aDocument.
	super visitDocument: aDocument.
	generator resolveReferences.
	instance := generator topInstance.
	^ instance! !

!XAInstanceGeneratingVisitor methodsFor: 'visiting' stamp: ' 6/23/2016 16:38:24'!
visitElement: anElement
	| result |
	result := true.
	(anElement name beginsWith: 'xmi:')
		ifFalse: [ result := generator processElement: anElement ].
	result ifNotNil: [ ^ super visitElement: anElement ]! !

XMLNodeVisitor subclass: #XATypeInferenceVisitor
	instanceVariableNames: 'collector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Core'!

!XATypeInferenceVisitor methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
collector: anInferenceCollector
	collector := anInferenceCollector! !

!XATypeInferenceVisitor methodsFor: 'as yet unclassified' stamp: ' 6/23/2016 16:38:24'!
visitElement: anElement
	collector inferElement: anElement.
	super visitElement: anElement! !

TestCase subclass: #XABaseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Tests'!

XABaseTest subclass: #XAAbstractGeneratorTest
	instanceVariableNames: 'generator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Tests'!

!XAAbstractGeneratorTest methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
generatorClass
	^ self subclassResponsibility! !

!XAAbstractGeneratorTest methodsFor: 'instance creation' stamp: ' 6/23/2016 16:38:24'!
newElement: aName
	^ self newElement: aName attributes: #()! !

!XAAbstractGeneratorTest methodsFor: 'instance creation' stamp: ' 6/23/2016 16:38:24'!
newElement: aName attributes: aCollection
	^ self
		newElement: aName
		attributes: aCollection
		namespaces:
			{(#uml -> 'http://schema.omg.org/spec/UML/2.1').
			(#xmi -> 'http://schema.omg.org/spec/XMI/2.1')}! !

!XAAbstractGeneratorTest methodsFor: 'instance creation' stamp: ' 6/23/2016 16:38:24'!
newElement: aString attributes: attributes namespaces: namespaces
	^ XMLElement name: aString namespaces: namespaces attributes: attributes! !

!XAAbstractGeneratorTest methodsFor: 'instance creation' stamp: ' 6/23/2016 16:38:24'!
newSimpleDom
	<script: 'self new newSimpleDom inspect'>
	^ XMLDOMParser parse: '<xmi:XMI xmi:version="2.1" xmlns:uml="http://schema.omg.org/spec/UML/2.1" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1" xmlns:thecustomprofile="http://www.sparxsystems.com/profiles/thecustomprofile/1.0">
	<packagedElement xmi:type="uml:Package" xmi:id="ID_0" name="State Machine Model" visibility="public">
		<subvertex xmi:type="uml:State" xmi:id="ID_1" name="State1" visibility="public" isSubmachineState="false">
			<incoming xmi:idref="ID_3"/>
		</subvertex>
		<transition xmi:type="uml:Transition" xmi:id="ID_3" visibility="public" kind="local" source="ID_2" target="ID_1"/>
		<subvertex xmi:type="uml:Pseudostate" xmi:id="ID_2" name="Initial" visibility="public" kind="initial">
			<outgoing xmi:idref="ID_3"/>
		</subvertex>
	</packagedElement>
</xmi:XMI>'! !

!XAAbstractGeneratorTest methodsFor: 'instance creation' stamp: ' 6/23/2016 16:38:24'!
newStructureDom
	<script: 'self new newStructureDom inspect'>
	^ XMLDOMParser parse: '<xmi:XMI xmi:version="2.1" xmlns:uml="http://schema.omg.org/spec/UML/2.1" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1" xmlns:thecustomprofile="http://www.sparxsystems.com/profiles/thecustomprofile/1.0">
	<packagedElement xmi:type="uml:Package" xmi:id="ID_0">
		<subvertex xmi:type="uml:State" xmi:id="ID_1">
			<incoming xmi:idref="ID_3"/>
		</subvertex>
		<transition xmi:type="uml:Transition" xmi:id="ID_3" source="ID_2" target="ID_1"/>
		<subvertex xmi:type="uml:Pseudostate" xmi:id="ID_2">
			<outgoing xmi:idref="ID_3"/>
		</subvertex>
	</packagedElement>
</xmi:XMI>'! !

!XAAbstractGeneratorTest methodsFor: 'running' stamp: ' 6/23/2016 16:38:24'!
setUp
	super setUp.
	generator := self generatorClass new.
	generator classPrefix: self classPrefix.
	generator packageName: self packageName! !

!XAAbstractGeneratorTest methodsFor: 'running' stamp: ' 6/23/2016 16:38:24'!
tearDown
	super tearDown.
	self cleanUpPackage! !

XAAbstractGeneratorTest subclass: #XAClassStructureGeneratorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Tests'!

!XAClassStructureGeneratorTest methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
generatorClass
	^ XAClassStructureGenerator! !

!XAClassStructureGeneratorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testClassName
	generator classPrefix: ''.
	self assert: (generator classNameFor: 'tagName' type: '') equals: 'TagName'.
	self assert: (generator classNameFor: 'tagName' type: 'uml:TagName') equals: 'TagName'.
	self assert: (generator classNameFor: 'tag:name' type: '') equals: 'Name'! !

!XAClassStructureGeneratorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testClassNameForElement
	generator classPrefix: ''.
	self assert: (generator classNameFor: (self newElement: 'tagName')) equals: 'TagName'.
	self
		assert:
			(generator
				classNameFor: (self newElement: 'tagName' attributes: {(#xmi:type -> 'uml:TagName')}))
		equals: 'TagName'! !

!XAClassStructureGeneratorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testClassNameNamespaced
	generator classPrefix: ''.
	generator useTypeNamespace: true.
	self assert: (generator classNameFor: 'tagName' type: '') equals: 'TagName'.
	self assert: (generator classNameFor: 'tagName' type: 'uml:TagName') equals: 'UmlTagName'.
	self assert: (generator classNameFor: 'tag:name' type: '') equals: 'TagName'! !

!XAClassStructureGeneratorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testDomStructure
	self newStructureDom allElements allButFirst
		do: [ :each | generator processElement: each ].
	generator createClassesInSystem.
	self
		assert:
			((RPackage organizer packageNamed: generator packageName) classes
				collect: [ :each | each name withoutPrefix: generator classPrefix ]) asSet
		equals: #(#State #Package #Pseudostate #Transition) asSet! !

!XAClassStructureGeneratorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testElementProcessing
	self newSimpleDom allElements do: [ :each | generator processElement: each ].
	generator createClassesInSystem.
	self
		assert: (generator classPrefix , 'Pseudostate') asClass instVarNames asSet
		equals: #(#xmiId #name #visibility #kind #outgoing #owner) asSet! !

!XAClassStructureGeneratorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testEnsureAttributeWithAccessor
	| cls |
	cls := generator ensureCreateClass: 'XAGSomething' in: generator packageName.
	self assert: cls instanceVariables asArray equals: #().
	generator ensureAttributeWithAccessor: #something in: cls.
	self assert: cls instanceVariables asSet equals: #(#something) asSet.
	self assert: cls selectors asSet equals: #(#something) asSet.
	generator createClassesInSystem.
	self
		assert: (#XAGSomething asClass >> #something) ast
		equals: (RBParser parseMethod: 'something ^ something')! !

!XAClassStructureGeneratorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testEnsureCreateClass
	| cls |
	cls := generator ensureCreateClass: 'XAGSomething' in: generator packageName.
	self assert: cls name equals: 'XAGSomething'.
	self assert: cls package equals: generator packageName! !

!XAClassStructureGeneratorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testIsReference
	self deny: (generator isReferenceOnly: (self newElement: 'el')).
	self
		assert: (generator isReferenceOnly: (self newElement: 'el' attributes: {(#xmi:idref -> 'x')}))! !

!XAClassStructureGeneratorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testOwnerReference
	self assert: generator ownerReference equals: 'owner'.
	generator ownerReference: 'ownerReference'.
	self assert: generator ownerReference equals: 'ownerReference'! !

!XAClassStructureGeneratorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testParent
	| dom |
	dom := self newStructureDom.
	self deny: (generator hasParent: dom root).
	self deny: (generator hasParent: dom allElements second).
	self assert: (generator hasParent: dom allElements third)! !

XAAbstractGeneratorTest subclass: #XAObjectInstanceGeneratorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Tests'!

!XAObjectInstanceGeneratorTest methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
generatorClass
	^ XAObjectInstanceGenerator! !

!XAObjectInstanceGeneratorTest methodsFor: 'running' stamp: ' 6/23/2016 16:38:24'!
setUp
	| classGenVisitor |
	super setUp.
	classGenVisitor := XACodeGeneratingVisitor new.
	classGenVisitor classPrefix: generator classPrefix.
	classGenVisitor packageName: generator packageName.
	classGenVisitor visit: self newSimpleDom! !

!XAObjectInstanceGeneratorTest methodsFor: 'running' stamp: ' 6/23/2016 16:38:24'!
tearDown
	"Do nothing. Don't wipe the XAG package so the classes don't have to be created for each instance test."! !

!XAObjectInstanceGeneratorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testCollectIds
	| ids |
	ids := generator collectIdsFrom: self newSimpleDom.
	self assert: (ids collect: #key) asSet equals: #(#ID_0 #ID_1 #ID_2 #ID_3) asSet! !

!XAObjectInstanceGeneratorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testContainment
	| parent child parentInstance childInstance dom |
	dom := self newStructureDom.
	parent := dom allElements second.
	child := parent elements first.
	parentInstance := generator createInstanceFor: parent.
	childInstance := generator createInstanceFor: child.
	self assert: parentInstance subvertex asArray equals: {childInstance}.
	self assert: childInstance owner equals: parentInstance! !

!XAObjectInstanceGeneratorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testReferenceIdref
	| dom source outgoing |
	dom := self newSimpleDom.
	generator inferTypesIn: dom.
	dom allElements allButFirst do: [ :each | generator processElement: each ].
	generator resolveReferences.
	source := generator topInstance subvertex detect: [ :each | each name = 'Initial' ].
	outgoing := generator topInstance transition first.
	self assert: source outgoing asArray equals: {outgoing}! !

!XAObjectInstanceGeneratorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testReferenceObscure
	| source dom transition target |
	dom := self newSimpleDom.
	generator inferTypesIn: dom.
	dom allElements allButFirst do: [ :each | generator processElement: each ].
	generator resolveReferences.
	transition := generator topInstance transition first.
	source := generator topInstance subvertex detect: [ :each | each name = 'Initial' ].
	target := generator topInstance subvertex detect: [ :each | each name = 'State1' ].
	self assert: transition source equals: source.
	self assert: transition target equals: target! !

!XAObjectInstanceGeneratorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testSetXmi
	| instance element |
	element := self newSimpleDom allElements third.
	instance := (generator classNameFor: element) asClass new.
	generator setXmiAttributesFrom: element to: instance.
	self assert: instance xmiId equals: (element attributeAt: #xmi:id)! !

!XAObjectInstanceGeneratorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testSingleInstance
	| dom instance |
	dom := self newSimpleDom.
	generator inferTypesIn: dom.
	generator createInstanceFor: dom allElements second.
	instance := generator createInstanceFor: dom allElements third.
	self assert: instance name equals: 'State1'.
	self assert: instance visibility equals: 'public'.
	self assert: instance xmiId equals: 'ID_1'! !

!XABaseTest methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
classPrefix
	^ 'XAG'! !

!XABaseTest methodsFor: 'running' stamp: ' 6/23/2016 16:38:24'!
cleanUpPackage
	(RPackage organizer includesPackageNamed: self packageName)
		ifTrue: [ (RPackage organizer packageNamed: self packageName) classes
				do: [ :each | each removeFromSystemUnlogged ] ]! !

!XABaseTest methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
packageName
	^ 'GeneratedClassesForXMITests'! !

XABaseTest subclass: #XADelayedClassTest
	instanceVariableNames: 'delayedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Tests'!

!XADelayedClassTest methodsFor: 'running' stamp: ' 6/23/2016 16:38:24'!
setUp
	super setUp.
	delayedClass := XADelayedClass
		name: self classPrefix , 'Delayed'
		parent: Object
		package: self packageName! !

!XADelayedClassTest methodsFor: 'running' stamp: ' 6/23/2016 16:38:24'!
tearDown
	delayedClass realClass ifNotNil: [ :cls | cls removeFromSystem ]! !

!XADelayedClassTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testAddDuplicateVariable
	delayedClass addInstVarNamed: 'something'.
	delayedClass addInstVarNamed: 'something'.
	self assert: delayedClass instanceVariables asArray equals: #(#something)! !

!XADelayedClassTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testAddInstVar
	self assert: delayedClass instanceVariables asArray equals: #().
	delayedClass addInstVarNamed: 'something'.
	self assert: delayedClass instanceVariables asArray equals: #(#something).
	self assert: delayedClass instVarNames asArray equals: #(#something)! !

!XADelayedClassTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testBasicClass
	| cls |
	cls := delayedClass save.
	self assert: delayedClass realClass equals: cls.
	self assert: cls className equals: self classPrefix , 'Delayed class'.
	self assert: cls superclass equals: Object.
	self assert: cls package name equals: self packageName.
	self assert: cls instanceVariables equals: #()! !

!XADelayedClassTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testCompileMethod
	| cls method |
	cls := Object subclass: delayedClass name.
	method := 'method ^ method'.
	self assert: cls selectors equals: #().
	delayedClass addMethod: method classified: 'accessing' to: cls.
	self assert: cls selectors equals: #(#method).
	self assert: (cls >> #method) ast equals: (RBParser parseMethod: method)! !

!XADelayedClassTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testHasVariable
	self deny: (delayedClass hasInstVarNamed: #something).
	delayedClass addInstVarNamed: #something.
	self assert: (delayedClass hasInstVarNamed: #something)! !

!XADelayedClassTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testMethod
	self assert: delayedClass selectors asSet equals: Set new.
	delayedClass compile: 'method ^ method' classified: 'accessing'.
	self assert: delayedClass selectors asSet equals: #(#method) asSet! !

!XADelayedClassTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testOverrideMethod
	| cls |
	delayedClass compile: 'method ^ 1' classified: 'accessing'.
	self assert: delayedClass selectors asSet equals: #(#method) asSet.
	delayedClass compile: 'method ^ 2' classified: 'accessing'.
	cls := delayedClass save.
	self assert: cls selectors equals: #(#method).
	self assert: (cls >> #method) ast equals: (RBParser parseMethod: 'method ^ 2')! !

!XADelayedClassTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testSaveMethod
	| cls method |
	method := 'method ^ method'.
	delayedClass compile: method classified: 'accessing'.
	cls := delayedClass save.
	self assert: cls selectors equals: #(#method).
	self assert: (cls >> #method) ast equals: (RBParser parseMethod: method)! !

!XADelayedClassTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testSetup
	self assert: delayedClass realClass equals: nil.
	self assert: delayedClass name equals: self classPrefix , 'Delayed'.
	self assert: delayedClass parent equals: Object.
	self assert: delayedClass package equals: self packageName.
	self assert: delayedClass instanceVariables asArray equals: #()! !

XABaseTest subclass: #XAGeneratingVisitorTest
	instanceVariableNames: 'visitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Tests'!

XAGeneratingVisitorTest subclass: #XACodeGeneratingVisitorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Tests'!

!XACodeGeneratingVisitorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testVisitDom
	visitor useTypeNamespace: true.
	visitor visitDocument: self newSimpleDom.
	self
		assert:
			((RPackage organizer packageNamed: self packageName) classes
				collect: [ :each | each name withoutPrefix: self classPrefix ]
				as: Set)
		equals: #(#UmlState #UmlPackage #UmlPseudostate #UmlTransition) asSet! !

!XACodeGeneratingVisitorTest methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
visitorClass
	^ XACodeGeneratingVisitor! !

!XAGeneratingVisitorTest methodsFor: 'instance creation' stamp: ' 6/23/2016 16:38:24'!
newSimpleDom
	<script: 'self new newSimpleDom inspect'>
	^ XMLDOMParser parse: '<xmi:XMI xmi:version="2.1" xmlns:uml="http://schema.omg.org/spec/UML/2.1" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1" xmlns:thecustomprofile="http://www.sparxsystems.com/profiles/thecustomprofile/1.0">
	<packagedElement xmi:type="uml:Package" xmi:id="ID_0" name="State Machine Model" visibility="public">
		<subvertex xmi:type="uml:State" xmi:id="ID_1" name="State1" visibility="public" isSubmachineState="false">
			<incoming xmi:idref="ID_3"/>
		</subvertex>
		<transition xmi:type="uml:Transition" xmi:id="ID_3" visibility="public" kind="local" source="ID_2" target="ID_1"/>
		<subvertex xmi:type="uml:Pseudostate" xmi:id="ID_2" name="Initial" visibility="public" kind="initial">
			<outgoing xmi:idref="ID_3"/>
		</subvertex>
	</packagedElement>
</xmi:XMI>'! !

!XAGeneratingVisitorTest methodsFor: 'running' stamp: ' 6/23/2016 16:38:24'!
setUp
	super setUp.
	(visitor := self visitorClass new)
		packageName: self packageName;
		useTypeNamespace: false;
		classPrefix: self classPrefix! !

!XAGeneratingVisitorTest methodsFor: 'running' stamp: ' 6/23/2016 16:38:24'!
tearDown
	super tearDown.
	self cleanUpPackage! !

!XAGeneratingVisitorTest methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
visitorClass
	^ self subclassResponsibility! !

XAGeneratingVisitorTest subclass: #XAInstanceGeneratingVisitorTest
	instanceVariableNames: 'codeVisitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Tests'!

!XAInstanceGeneratingVisitorTest methodsFor: 'running' stamp: ' 6/23/2016 16:38:24'!
setUp
	super setUp.
	(codeVisitor := XACodeGeneratingVisitor new)
		packageName: self packageName;
		classPrefix: self classPrefix! !

!XAInstanceGeneratingVisitorTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testDom
	| package dom |
	dom := self newSimpleDom.
	codeVisitor visit: dom.
	package := visitor visitDocument: dom.
	self assert: package className equals: self classPrefix , #Package.
	self assert: package subvertex size equals: 2.
	self assert: package transition size equals: 1! !

!XAInstanceGeneratingVisitorTest methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
visitorClass
	^ XAInstanceGeneratingVisitor! !

XABaseTest subclass: #XATypeInferenceTest
	instanceVariableNames: 'inference result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Tests'!

!XATypeInferenceTest methodsFor: 'instance creation' stamp: ' 6/23/2016 16:38:24'!
newSimpleDom
	<script: 'self new newSimpleDom inspect'>
	^ XMLDOMParser
		parse:
			'<xmi:XMI xmi:version="2.1" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
	<container xmi:id="ID_C_1" name="Container">
		<node xmi:id="ID_N_1" name="First Node" property="false">
			<outgoing xmi:idref="ID_E_1"/>
		</node>
		<node xmi:id="ID_N_2" name="First Node" property="true">
			<incoming xmi:idref="ID_E_1"/>
			<outgoing xmi:idref="ID_E_2"/>
		</node>
		<node xmi:id="ID_N_3" name="First Node" size="10">
			<incoming xmi:idref="ID_E_1"/>
			<incoming xmi:idref="ID_E_2"/>
		</node>
		<edge xmi:id="ID_E_1" source="ID_N_1" target="ID_N_2 ID_N_3"/>
		<edge xmi:id="ID_E_2" source="ID_N_2" target="ID_N_3"/>
	</container>
</xmi:XMI>'! !

!XATypeInferenceTest methodsFor: 'running' stamp: ' 6/23/2016 16:38:24'!
setUp
	super setUp.
	inference := XATypeInference new! !

!XATypeInferenceTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testCache
	self assert: (inference cacheAt: #A at: #B) equals: #EMPTY.
	inference cacheAt: #A at: #B put: 42.
	self assert: (inference cacheAt: #A at: #B) equals: 42! !

!XATypeInferenceTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testCastAttribute
	| el |
	el := XMLElement
		name: 'element'
		attributes: (Array with: #prop -> 'false' with: #num -> '12' with: #name -> 'str').
	inference inferElement: el.
	self assert: (inference castAttribute: el attributeNodes first) equals: false.
	self assert: (inference castAttribute: el attributeNodes second) equals: 12.
	self assert: (inference castAttribute: el attributeNodes third) equals: 'str'! !

!XATypeInferenceTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testCastIdrefAttribute
	| el |
	el := XMLElement
		name: 'element'
		attributes: (Array with: #refs -> 'ID_1 ID_2' with: #ref -> 'ID_1').
	inference idRefs: #(#ID_1 #ID_2).
	inference inferElement: el.
	self assert: (inference castAttribute: el attributeNodes first) equals: #('ID_1' 'ID_2').
	self assert: (inference castAttribute: el attributeNodes second) equals: 'ID_1'! !

!XATypeInferenceTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testChooseBetween
	self assert: (inference chooseBetween: #String and: #String) equals: #String.
	self assert: (inference chooseBetween: #Integer and: #String) equals: #String.
	self assert: (inference chooseBetween: #EMPTY and: #String) equals: #String.
	self assert: (inference chooseBetween: #IDREF and: #IDREFS) equals: #IDREFS.
	self assert: (inference chooseBetween: #Integer and: #Number) equals: #Number.
	self assert: (inference chooseBetween: #Integer and: #Float) equals: #Float.
	self assert: (inference chooseBetween: #ID and: #ID) equals: #ID.! !

!XATypeInferenceTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testCollectIds
	| ids |
	ids := inference collectIdsFrom: self newSimpleDom.
	self assert: ids asSet equals: #(#ID_C_1 #ID_N_1 #ID_N_2 #ID_N_3 #ID_E_1 #ID_E_2) asSet! !

!XATypeInferenceTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testDom
	| dom |
	dom := self newSimpleDom.
	self
		assert: (inference inferDocument: dom)
		equals:
			(Dictionary new
				add: #container -> (Dictionary with: #name -> #String with: #xmi:id -> #ID);
				add:
					#node
						->
							(Dictionary
								with: #name -> #String
								with: #property -> #Boolean
								with: #xmi:id -> #ID
								with: 'size' -> #Integer);
				add:
					#edge
						-> (Dictionary with: #source -> #IDREF with: #target -> #IDREFS with: #xmi:id -> #ID);
				add: #incoming -> (Dictionary with: #xmi:idref -> #IDREF);
				add: #outgoing -> (Dictionary with: #xmi:idref -> #IDREF);
				add: #xmi:XMI -> (Dictionary with: 'xmi:version' -> #Float);
				yourself)! !

!XATypeInferenceTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testElement
	| element |
	element := XMLElement
		name: 'name'
		attributes: (Dictionary with: #name -> 'Str' with: #prop -> 'false').
	self
		assert: (inference inferElement: element)
		equals: (Dictionary with: #name -> #String with: #prop -> #Boolean)! !

!XATypeInferenceTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testEmpty
	self assert: (inference inferValue: '') equals: #EMPTY! !

!XATypeInferenceTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testIdref
	self assert: (inference inferValue: 'ID_1') equals: #String.
	inference idRefs: #(#ID_1).
	self assert: (inference inferValue: 'ID_1') equals: #IDREF! !

!XATypeInferenceTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testIdrefs
	self assert: (inference inferValue: 'ID_1 ID_2') equals: #String.
	inference idRefs: #(#ID_1 #ID_2).
	self assert: (inference inferValue: 'ID_1 ID_2') equals: #IDREFS! !

!XATypeInferenceTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testInferBoolean
	self assert: (inference inferValue: 'true') equals: #Boolean.
	self assert: (inference inferValue: 'false') equals: #Boolean! !

!XATypeInferenceTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testInferDowngrade
	| el el2 |
	el := XMLElement name: 'element' attributes: {(#key -> 'hello')}.
	el2 := XMLElement name: 'element' attributes: {(#key -> '12')}.
	self assert: (inference inferAttribute: el attributeNodes first) equals: #String.
	self assert: (inference inferAttribute: el2 attributeNodes first) equals: #String! !

!XATypeInferenceTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testInferIdrefToIdrefs
	| el el2 |
	inference idRefs: #(#ID_1 #ID_2).
	el := XMLElement name: 'element' attributes: {(#key -> 'ID_1')}.
	el2 := XMLElement name: 'element' attributes: {(#key -> 'ID_1 ID_2')}.
	self assert: (inference inferAttribute: el attributeNodes first) equals: #IDREF.
	self assert: (inference inferAttribute: el2 attributeNodes first) equals: #IDREFS! !

!XATypeInferenceTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testInferNumber
	self assert: (inference inferValue: '1') equals: #Integer.
	self assert: (inference inferValue: '1.2') equals: #Float! !

!XATypeInferenceTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testInferSingleAttribute
	| el |
	el := XMLElement name: 'element' attributes: {(#key -> 'value')}.
	self assert: (inference inferAttribute: el attributeNodes first) equals: #String! !

!XATypeInferenceTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testInferString
	self assert: (inference inferValue: 'ID_1') equals: #String.
	self assert: (inference inferValue: 'Name') equals: #String.
	self assert: (inference inferValue: 'public') equals: #String! !

XABaseTest subclass: #XMIAnalayzerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Tests'!

!XMIAnalayzerTest methodsFor: 'instance creation' stamp: ' 6/23/2016 16:38:24'!
newDom
	^ XMIAnalyzer sampleStateMachineXmi! !

!XMIAnalayzerTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
tearDown
	super tearDown.
	self cleanUpPackage! !

!XMIAnalayzerTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testCreateClasses
	XMIAnalyzer createClassesFor: self newDom prefixed: self classPrefix in: self packageName.
	self assert: (RPackage organizer packageNamed: self packageName) classes isNotEmpty! !

!XMIAnalayzerTest methodsFor: 'tests' stamp: ' 6/23/2016 16:38:24'!
testCreateInstance
	| instance |
	XMIAnalyzer createClassesFor: self newDom prefixed: self classPrefix in: self packageName.
	instance := XMIAnalyzer createInstanceOf: self newDom prefixed: self classPrefix.
	self assert: instance className equals: self classPrefix , 'Model'! !

!XMIAnalayzerTest methodsFor: 'tests - naive' stamp: ' 6/23/2016 16:38:24'!
testExample
	XMIAnalyzer exampleStateMachineScenario! !

!XMIAnalayzerTest methodsFor: 'tests - naive' stamp: ' 6/23/2016 16:38:24'!
testSample
	XMIAnalyzer sampleStateMachineScenario! !

TestCase subclass: #XAMagicDrawTest
	instanceVariableNames: 'mooseModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Tests'!

!XAMagicDrawTest methodsFor: 'as yet unclassified' stamp: 'usmanbhatti 7/4/2016 16:12'!
magicDrawExample
	^ '<?xml version=''1.0'' encoding=''UTF-8''?>

<xmi:XMI xmlns:uml=''http://www.omg.org/spec/UML/20110701'' xmlns:xmi=''http://www.omg.org/spec/XMI/20110701'' xmlns:Validation_Profile=''http://www.magicdraw.com/schemas/Validation_Profile.xmi'' xmlns:StandardProfileL3=''http://www.omg.org/spec/UML/20110701/StandardProfileL3'' xmlns:DSL_Customization=''http://www.magicdraw.com/schemas/DSL_Customization.xmi'' xmlns:MagicDraw_Profile=''http://www.omg.org/spec/UML/20110701/MagicDrawProfile''>

<xmi:Documentation><xmi:exporter>MagicDraw UML</xmi:exporter><xmi:exporterVersion>17.0.4</xmi:exporterVersion></xmi:Documentation><uml:Model xmi:type="uml:Model" xmi:id="NCK_id_0" name="NCK@@/NCK103"><packagedElement xmi:type="uml:Package" xmi:id="nck_p_/NIVEAU1" name="NIVEAU1"><ownedComment xmi:type="uml:Comment" xmi:id="nck_cm_nck_p_/NIVEAU1" body="@FG: 
@MA: 
@New Name: 
@Comment: 
"><annotatedElement xmi:idref="nck_p_/NIVEAU1"/></ownedComment><packagedElement xmi:type="uml:Package" xmi:id="nck_p_NIVEAU1/BSL1" name="BSL1"><ownedComment xmi:type="uml:Comment" xmi:id="nck_cm_nck_p_NIVEAU1/BSL1" body="@FG: 
@MA: 
@New Name: 
@Comment: 
">
<annotatedElement xmi:idref="nck_p_NIVEAU1/BSL1"/></ownedComment><packagedElement xmi:type="uml:Enumeration" xmi:id="nck_e_B1S3Li4Data::B1S3Li4O1C3" name="B1S3Li4Data::B1S3Li4O1C3"><ownedComment xmi:type="uml:Comment" xmi:id="nck_cm_nck_e_B1S3Li4Data::B1S3Li4O1C3" body="@FG: Groupe6
@MA: Collegue1
@Weight: 0
@Files: B1S3Li4data.hh
@new File: 
@New Name: 
@Comment: 
">
<annotatedElement xmi:idref="nck_e_B1S3Li4Data::B1S3Li4O1C3"/></ownedComment></packagedElement><packagedElement xmi:type="uml:Enumeration" xmi:id="nck_e_B1S3Li4Data::B1S3Li4sh1" name="B1S3Li4Data::B1S3Li4sh1"><ownedComment xmi:type="uml:Comment" xmi:id="nck_cm_nck_e_B1S3Li4Data::B1S3Li4sh1" body="@FG: Groupe6
@MA: Collegue1
@Weight: 0
@Files: B1S3Li4data.hh
@new File: 
@New Name: 
@Comment: 
"><annotatedElement xmi:idref="nck_e_B1S3Li4Data::B1S3Li4sh1"/></ownedComment></packagedElement><packagedElement xmi:type="uml:Enumeration" xmi:id="nck_e_B1S3Li4Data::B1S3Li4Type" name="B1S3Li4Data::B1S3Li4Type"><ownedComment xmi:type="uml:Comment" xmi:id="nck_cm_nck_e_B1S3Li4Data::B1S3Li4Type" body="@FG: Groupe6
@MA: Collegue1
@Weight: 0
@Files: B1S3Li4data.hh
@new File: 
@New Name: 
@Comment: 
"><annotatedElement xmi:idref="nck_e_B1S3Li4Data::B1S3Li4Type"/></ownedComment></packagedElement><packagedElement xmi:type="uml:Enumeration" xmi:id="nck_e_BSswlTlkResult" name="BSswlTlkResult"><ownedComment xmi:type="uml:Comment" xmi:id="nck_cm_nck_e_BSswlTlkResult" body="@FG: Groupe6
@MA: Collegue1
@Weight: 0
@Files: bsswltlk.hh
@new File: 
@New Name: 
@Comment: 
">
<annotatedElement xmi:idref="nck_e_BSswlTlkResult"/></ownedComment></packagedElement><packagedElement xmi:type="uml:Enumeration" xmi:id="nck_e_C6L10::OptType" name="C6L10::OptType"><ownedComment xmi:type="uml:Comment" xmi:id="nck_cm_nck_e_C6L10::OptType" body="@FG: Groupe6
@MA: Collegue1
@Weight: 0
@Files: licence.h
@new File: 
@New Name: 
@Comment: 
"><annotatedElement xmi:idref="nck_e_C6L10::OptType"/></ownedComment></packagedElement></packagedElement>
<packagedElement xmi:type="uml:Class" xmi:id="nck_c_K103FR10" name="K103FR10"><ownedComment xmi:type="uml:Comment" xmi:id="nck_cm_nck_c_K103FR10" body="@FG: Groupe5
@MA: 
@Weight: 20
@Files: K103FR10.hh K103FR10.icc K103FR10.cc
@new File: 
@New Name: 
@Comment: 
"><annotatedElement xmi:idref="nck_c_K103FR10"/></ownedComment><generalization xmi:type="uml:Generalization" xmi:id="nck_gen_nck_c_S1ob4_nck_c_K103FR10" general="B1S3Li4Data::B1S3Li4Type"><ownedComment xmi:type="uml:Comment" xmi:id="nck_cm_nck_gen_nck_c_S1ob4_nck_c_K103FR10" body="@Comment: 
@Num Dest Symbols: 4
@Num Source Ops: 6
@Num Connections: 12
@Symlist: 
(6) S1ob4::~S1ob4()
(5) S1ob4::S1ob4()
(1) operator=(const S1ob4)
(0) S1ob4
"><annotatedElement xmi:idref="nck_gen_nck_c_S1ob4_nck_c_K103FR10"/></ownedComment></generalization><ownedAttribute xmi:type="uml:Property" xmi:id="nck_attr_nck_c_K103FR10_nck_c_K103rot10" visibility="private" type="nck_c_K103rot10" association="nck_asc_nck_c_K103FR10_nck_c_K103rot10"><xmi:Extension extender="MagicDraw UML 17.0.4"><modelExtension><lowerValue xmi:type="uml:LiteralInteger" xmi:id="_17_0_4_c8e0294_1463156929583_326943_7648" value="1"/></modelExtension></xmi:Extension><xmi:Extension extender="MagicDraw UML 17.0.4"><modelExtension><upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_17_0_4_c8e0294_1463156929583_752173_7649" value="1"/></modelExtension></xmi:Extension></ownedAttribute></packagedElement>
</packagedElement>

	</uml:Model>
</xmi:XMI>'! !

!XAMagicDrawTest methodsFor: 'as yet unclassified' stamp: 'usmanbhatti 7/4/2016 12:36'!
setUp
	| dom umlModel visitor |
	dom := XMLDOMParser parse: self magicDrawExample.
	umlModel := dom root elements second.	"selecting just the <uml:Model> node with its children"
	visitor := XAInstanceGeneratingVisitor new.
	visitor generator: XAMagicDrawToMooseGenerator new.
	visitor generator inferTypesIn: umlModel.
	visitor classPrefix: ''.
	visitor visit: umlModel.
	visitor generator resolveReferences.
	mooseModel := visitor generator topInstance! !

!XAMagicDrawTest methodsFor: 'as yet unclassified' stamp: 'usmanbhatti 7/4/2016 14:54'!
testComments
	self assert:  mooseModel allPackages first comments size > 0 description: 'No Packages found in MooseModel'.
	self assert: mooseModel allPackages first comments first content size > 0 description: 'Comment cannot be empty'! !

!XAMagicDrawTest methodsFor: 'as yet unclassified' stamp: 'usmanbhatti 7/4/2016 16:48'!
testInheritance
	self assert: mooseModel allTypes first superInheritances first to isNotNil description: 'Super class of the inheritance is nil'! !

!XAMagicDrawTest methodsFor: 'as yet unclassified' stamp: 'usmanbhatti 7/4/2016 12:36'!
testNumberOfPackages
	self assert:  mooseModel allPackages size equals: 2! !

!XAMagicDrawTest methodsFor: 'as yet unclassified' stamp: 'usmanbhatti 7/4/2016 14:25'!
testPackageRelationship
	self assert: (mooseModel allPackages entityNamed: 'BSL1') parentPackage name equals: 'NIVEAU1'! !

!XAMagicDrawTest methodsFor: 'as yet unclassified' stamp: 'usmanbhatti 7/4/2016 16:15'!
testTypes
	self assert:  mooseModel allTypes size equals: 6.
	self assert: mooseModel allTypes first container name equals: 'NIVEAU1'.
	self assert: mooseModel allTypes second container name equals: 'BSL1'! !

!MooseModel methodsFor: '*XMI-Analyzer' stamp: 'usmanbhatti 7/4/2016 12:19'!
accept: aVisitor
	aVisitor visitModel: self! !

Object subclass: #XAAbstractGenerator
	instanceVariableNames: 'packageName classPrefix ownerReference useTypeNamespace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Core'!

!XAAbstractGenerator commentStamp: 'PeterUhnak 4/29/2016 14:20' prior: 0!
I provide some common interface to both class and object generators.!

!XAAbstractGenerator methodsFor: 'normalizing' stamp: ' 6/23/2016 16:38:24'!
classNameFor: anElement
	^ self classNameFor: anElement name type: (anElement attributeAt: #xmi:type)! !

!XAAbstractGenerator methodsFor: 'normalizing' stamp: ' 6/23/2016 16:38:24'!
classNameFor: anElementName type: aTypeName
	| parts |
	parts := (aTypeName ifEmpty: [ anElementName ]) splitOn: ':'.
	self useTypeNamespace
		ifFalse: [ parts := {parts last} ].
	^ self classPrefix , ((parts collect: #capitalized) joinUsing: '')! !

!XAAbstractGenerator methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
classPrefix
	^ classPrefix! !

!XAAbstractGenerator methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
classPrefix: aString
	classPrefix := aString! !

!XAAbstractGenerator methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
ownerReference
	^ ownerReference ifNil: [ 'owner' ]! !

!XAAbstractGenerator methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
ownerReference: aString
	"Name to use for reference to the owner, in case there is a naming conflict."
	ownerReference := aString! !

!XAAbstractGenerator methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
packageName
	^ packageName! !

!XAAbstractGenerator methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
packageName: aString
	packageName := aString! !

!XAAbstractGenerator methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
useTypeNamespace
	^ useTypeNamespace ifNil: [ useTypeNamespace := false ]! !

!XAAbstractGenerator methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
useTypeNamespace: aBoolean
	useTypeNamespace := aBoolean! !

XAAbstractGenerator subclass: #XAClassStructureGenerator
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Core'!

!XAClassStructureGenerator commentStamp: 'PeterUhnak 4/28/2016 14:07' prior: 0!
I analyze an XMI file and generate a semi-appropriate object representation by creating new classes in a target package.!

!XAClassStructureGenerator methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
classFor: aName
	^ classes at: aName! !

!XAClassStructureGenerator methodsFor: 'xml processing' stamp: ' 6/23/2016 16:38:24'!
createAttributesFor: anElement in: aClass
	(anElement attributeAt: #xmi:id)
		ifNotEmpty: [ self ensureAttributeWithAccessor: #xmiId in: aClass ].
	anElement attributeNodes
		reject: [ :each | each name includes: $: ]
		thenDo: [ :each | self ensureAttributeWithAccessor: each name in: aClass ]! !

!XAClassStructureGenerator methodsFor: 'xml processing' stamp: ' 6/23/2016 16:38:24'!
createClassFor: anElement
	| cls |
	cls := self ensureCreateClass: (self classNameFor: anElement) in: self packageName.
	self createAttributesFor: anElement in: cls! !

!XAClassStructureGenerator methodsFor: 'code generation' stamp: ' 6/23/2016 16:38:24'!
createClassesInSystem
	classes do: #save! !

!XAClassStructureGenerator methodsFor: 'code generation' stamp: ' 6/23/2016 16:38:24'!
ensureAttributeWithAccessor: aName in: aClass
	aClass addInstVarNamed: aName.
	aClass
		compile:
			('{1}
	^ {1}' format: {aName})
		classified: 'accessing'! !

!XAClassStructureGenerator methodsFor: 'code generation' stamp: ' 6/23/2016 16:38:24'!
ensureCreateClass: aName in: aPackage
	^ classes
		at: aName
		ifAbsentPut: [ XADelayedClass name: aName parent: Object package: aPackage ]! !

!XAClassStructureGenerator methodsFor: 'testing' stamp: ' 6/23/2016 16:38:24'!
hasParent: anElement
	"The topmost root is not generated, so don't generate accessors there. Some tests also provide just a fragment of XML tree which would fail on missing parent."

	^ (anElement isRoot or: [ anElement parent isNotNil and: [ anElement parent isRoot ] ])
		not! !

!XAClassStructureGenerator methodsFor: 'initialization' stamp: ' 6/23/2016 16:38:24'!
initialize
	super initialize.
	classes := Dictionary new! !

!XAClassStructureGenerator methodsFor: 'testing' stamp: ' 6/23/2016 16:38:24'!
isReferenceOnly: anElement
	^ (anElement attributeAt: #xmi:idref) isNotEmpty! !

!XAClassStructureGenerator methodsFor: 'xml processing' stamp: ' 6/23/2016 16:38:24'!
processElement: anElement
	(self isReferenceOnly: anElement)
		ifFalse: [ self createClassFor: anElement.
			self
				ensureAttributeWithAccessor: self ownerReference
				in: (self classFor: (self classNameFor: anElement)) ].
	(self hasParent: anElement)
		ifTrue: [ self
				ensureAttributeWithAccessor: anElement name
				in: (self classFor: (self classNameFor: anElement parent)) ]! !

XAAbstractGenerator subclass: #XAObjectInstanceGenerator
	instanceVariableNames: 'inference classGenerator topInstance instances ids unresolved'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Core'!

!XAObjectInstanceGenerator commentStamp: 'PeterUhnak 4/29/2016 14:18' prior: 0!
I instantiate XMI elements as objects on classes generated from XMIClassStructureGenerator!

XAObjectInstanceGenerator subclass: #XAMagicDrawToMooseGenerator
	instanceVariableNames: 'node parent currentElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Core'!

!XAMagicDrawToMooseGenerator commentStamp: 'usmanbhatti 7/4/2016 16:48' prior: 0!
Extracts UML description from XMI exported from Magic draw and creates a moose model for these entities.!

!XAMagicDrawToMooseGenerator class methodsFor: 'example' stamp: ' 6/23/2016 16:38:24'!
example
|dom model visitor|
dom := XMLDOMParser parse: FileLocator home asFileReference / 'prog/synectique/nck_Niveau_1.xmi'.
model := dom root elements second.

visitor := XAInstanceGeneratingVisitor new.
visitor generator: XAMagicDrawToMooseGenerator new.
visitor generator inferTypesIn: model.
visitor classPrefix: ''.
visitor visit: dom root elements second.
visitor generator resolveReferences.
model := visitor generator topInstance.! !

!XAMagicDrawToMooseGenerator methodsFor: 'instantiating' stamp: 'usmanbhatti 7/4/2016 16:42'!
addReference: aChild to: aParent at: aName
	"Here a message mapping should be defined how the children should be added to the parents.

In XMI normally the parent element has an attribute with the name of the child element, e.g.

<uml:Model xmi:type='uml:Model' xmi:id='id_0' name='Model0'>
	<packagedElement xmi:type='uml:Package' xmi:id='pkg_1' name='PKG1'>
</uml:Model>

So a Model would have an attribute called 'packagedElement' that would have a collection of packagedElements.

In Moose however, the relationships are different, so you must say in what way.

E.g. you can just do aMooseModel add: aFAMIXPackage. However for other parts attributes are needed. XMI/UML and FAMIX do not have the same model, so its a bit tricky."

	node accept: self.
	"I don't know how packages inside packages are represented in Moose, there is FAMIXPackageGroup, but that cannot have FAMIXComments..."
	"((aParent isKindOf: FAMIXPackage) and: [ aChild isKindOf: FAMIXPackage ])
		ifTrue: [ ^ aParent mooseModel add: aChild ].
	((aParent isKindOf: FAMIXPackage) and: [ aChild isKindOf: FAMIXType ])
		ifTrue: [ ^ aParent addType: aChild ]."
	"The owner of a Generalization is the child"
	"((aChild isKindOf: FAMIXInheritance) and: [ aName = #generalization ])
		ifTrue: [ ^ aParent addSuperInheritance: aChild ].
	(aChild isKindOf: FAMIXReference)
		ifTrue: [ ^ aParent addSuperInheritance: aChild ]."

	"Any FAMIXSourcedEntity can have comments"
	"aName = #ownedComment
		ifTrue: [ ^ aParent addComment: aChild ]."
	"A Comment in UML has an owner (#ownedComment) and an annotatedElement, but I don't remember the exact mechanics of who the comment is actually commenting... please refer to the specs, here I will just use ownedComment and ignore annotatedElement"
	"aName = #annotatedElement
		ifTrue: [ ^ self ].
	1 halt"! !

!XAMagicDrawToMooseGenerator methodsFor: 'normalizing' stamp: 'usmanbhatti 7/4/2016 16:18'!
classNameFor: anElementName type: aTypeName
	^ (Dictionary new
		at: 'uml:Model' put: #MooseModel;
		at: 'uml:Package' put: #FAMIXPackage;
		at: 'uml:Comment' put: #FAMIXComment;
		at: 'uml:Enumeration' put: #FAMIXEnum;
		at: 'uml:Class' put: #FAMIXClass;
		at: 'uml:Generalization' put: #FAMIXInheritance;
		"currently we do not take into account uml:dependency"
		at: 'uml:Dependency' put: nil;
		"We are not interested in attributes, associations and other things"
			at: 'uml:Property' put: nil;
		at: 'uml:Association' put: nil;
		yourself)
		at: aTypeName
		ifAbsent: [ 	super classNameFor: anElementName type: aTypeName ]! !

!XAMagicDrawToMooseGenerator methodsFor: 'instantiating' stamp: 'usmanbhatti 7/4/2016 15:09'!
elementName
	^ currentElement attributeAt: 'name'! !

!XAMagicDrawToMooseGenerator methodsFor: 'instantiating' stamp: 'usmanbhatti 7/4/2016 15:24'!
resolveReference: anElement
	anElement name = 'type'
		ifTrue: [ ^ self ].
	(anElement isRoot or: [ anElement parent isNil or: [ anElement parent isRoot ] ])
		ifTrue: [ ^ self ].
	parent := instances at: anElement parent.
	(anElement attributeAt: #xmi:idref)
		ifEmpty: [ node := instances at: anElement.
			currentElement := anElement.
			self addReference: node to: parent at: anElement name.
			self setReference: parent to: node at: self ownerReference ]
		ifNotEmpty: [ :idref | 
			unresolved
				add: [ self addReference: (instances at: (ids at: idref)) to: parent at: anElement name ] ]! !

!XAMagicDrawToMooseGenerator methodsFor: 'instantiating' stamp: 'usmanbhatti 7/4/2016 16:44'!
setReference: aChild to: aParent at: aName
	"Setting reference to MooseModel for a Package"

	"((aChild isKindOf: MooseModel) and: [ aParent isKindOf: FAMIXPackage ])
		ifTrue: [ ^ aParent mooseModel: aChild ].
	aName = #owner
		ifTrue: [ ^ aParent mooseModel: aChild mooseModel ]."
	aName = #body ifTrue: [ aParent content: aChild ].
	"Setting attributes of a Comment"
	"in XMI, the content is stored in 'body' attribute; in FAMIX in 'content'"
	"((aParent isKindOf: FAMIXComment) and: [ aName = #body ])
		ifTrue: [ ^ aParent content: aChild ]."
	"setting name"
	"((aParent isKindOf: FAMIXNamedEntity) | (aParent isKindOf: MooseModel) and: [ aName = #name ])
		ifTrue: [ ^ aParent name: aChild ]."
	"(aParent isKindOf: FAMIXInheritance)
		ifTrue: [ ^ aChild addSubInheritance: aParent ]."
	"1 halt"! !

!XAMagicDrawToMooseGenerator methodsFor: 'instantiating' stamp: ' 6/23/2016 16:38:24'!
setXmiAttributesFrom: anElement to: anInstance
	"Moose uses numeric IDs, so I am not sure what should be the proper behavior here.. maybe a mapping table between MagicDraw IDs and Moose IDs"

	(anElement attributeAt: #xmi:id)
		ifNotEmpty: [ :id | anInstance instVarNamed: #mooseID put: id ]! !

!XAMagicDrawToMooseGenerator methodsFor: 'visiting' stamp: 'usmanbhatti 7/4/2016 14:29'!
visitClass: aClass
	self visitType: aClass! !

!XAMagicDrawToMooseGenerator methodsFor: 'visiting' stamp: 'usmanbhatti 7/4/2016 14:55'!
visitComment: aComment
	parent addComment: aComment.
	aComment mooseModel: parent mooseModel! !

!XAMagicDrawToMooseGenerator methodsFor: 'visiting' stamp: 'usmanbhatti 7/4/2016 15:23'!
visitInheritance: aFamixInheritance
	(parent addSuperInheritance: aFamixInheritance).
	aFamixInheritance mooseModel: parent mooseModel! !

!XAMagicDrawToMooseGenerator methodsFor: 'visiting' stamp: 'usmanbhatti 7/4/2016 16:37'!
visitModel: aMooseModel
	aMooseModel add: node! !

!XAMagicDrawToMooseGenerator methodsFor: 'visiting' stamp: 'usmanbhatti 7/4/2016 16:45'!
visitPackage: aPackage
	 aPackage name: self elementName.
	(parent class = MooseModel) 
		ifFalse: [
			aPackage mooseModel: parent mooseModel. 
			parent addChildNamedEntity: aPackage.
			]
		ifTrue: [ aPackage mooseModel: parent ]! !

!XAMagicDrawToMooseGenerator methodsFor: 'visiting' stamp: 'usmanbhatti 7/4/2016 15:09'!
visitType: aType
	parent addType: aType.
	aType
		mooseModel: parent mooseModel;
		name: self elementName! !

!XAObjectInstanceGenerator methodsFor: 'instantiating' stamp: ' 6/23/2016 16:38:24'!
addReference: aChild to: aParent at: aName
	(aParent instVarNamed: aName)
		ifNil: [ aParent instVarNamed: aName put: OrderedCollection new ].
	(aParent instVarNamed: aName) add: aChild! !

!XAObjectInstanceGenerator methodsFor: 'resolving' stamp: ' 6/23/2016 16:38:24'!
collectIdsFrom: aDocument
	^ (aDocument allElements collect: [ :each | (each attributeAt: #xmi:id) -> each ])
		reject: [ :each | each key isEmpty ]! !

!XAObjectInstanceGenerator methodsFor: 'instantiating' stamp: ' 6/23/2016 16:38:24'!
createInstanceFor: anElement
	| name |
	name := self classNameFor: anElement.
	name ifNil: [ ^ nil ].
	^ self createInstanceFor: anElement class: name asClass! !

!XAObjectInstanceGenerator methodsFor: 'instantiating' stamp: 'usmanbhatti 7/4/2016 15:01'!
createInstanceFor: anElement class: aClass
	| instance |
	instance := aClass new.
	self setXmiAttributesFrom: anElement to: instance.
	self setAttributesFrom: anElement to: instance.
	instances ifEmpty: [ topInstance := instance ].
	instances at: anElement put: instance.
	self resolveReference: anElement.
	^ instance! !

!XAObjectInstanceGenerator methodsFor: 'resolving' stamp: ' 6/23/2016 16:38:24'!
inferTypesIn: aDocument
	ids := (self collectIdsFrom: aDocument) asDictionary.
	inference := XATypeInference new.
	inference inferDocument: aDocument.
	^ inference! !

!XAObjectInstanceGenerator methodsFor: 'initialization' stamp: ' 6/23/2016 16:38:24'!
initialize
	super initialize.
	ids := Dictionary new.
	inference := XATypeInference new.
	instances := Dictionary new.
	unresolved := OrderedCollection new! !

!XAObjectInstanceGenerator methodsFor: 'public' stamp: ' 6/23/2016 16:38:24'!
processElement: anElement
	^ (anElement attributeAt: #xmi:idref)
		ifNotEmpty: [ self resolveReference: anElement ]
		ifEmpty: [ self createInstanceFor: anElement ]! !

!XAObjectInstanceGenerator methodsFor: 'resolving' stamp: ' 6/23/2016 16:38:24'!
resolveReference: anElement
	| parent child |
	anElement name = 'type'
		ifTrue: [ ^ self ].
	(anElement isRoot or: [ anElement parent isNil or: [ anElement parent isRoot ] ])
		ifTrue: [ ^ self ].
	parent := instances at: anElement parent.
	(anElement attributeAt: #xmi:idref)
		ifEmpty: [ child := instances at: anElement.
			self addReference: child to: parent at: anElement name.
			self setReference: parent to: child at: self ownerReference ]
		ifNotEmpty: [ :idref | 
			unresolved
				add: [ self addReference: (instances at: (ids at: idref)) to: parent at: anElement name ] ]! !

!XAObjectInstanceGenerator methodsFor: 'resolving' stamp: ' 6/23/2016 16:38:24'!
resolveReferences
	unresolved do: #value! !

!XAObjectInstanceGenerator methodsFor: 'instantiating' stamp: ' 6/23/2016 16:38:24'!
setAttributesFrom: anElement to: instance
	anElement attributeNodes
		select: [ :each | (each name includes: $:) not ]
		thenDo: [ :each | 
			| type value |
			type := inference typeForAttribute: each.
			value := inference castAttribute: each.
			type = #IDREF
				ifTrue: [ unresolved add: [ self setReference: (instances at: (ids at: value)) to: instance at: each name ] ].
			type = #IDREFS
				ifTrue:
					[ unresolved add: [ value do: [ :val | self addReference: (instances at: (ids at: val)) to: instance at: each name ] ] ].
			type = #IDREF | (type = #IDREFS)
				ifFalse: [ self setReference: value to: instance at: each name ] ]! !

!XAObjectInstanceGenerator methodsFor: 'instantiating' stamp: ' 6/23/2016 16:38:24'!
setReference: aChild to: aParent at: aName
	aParent instVarNamed: aName put: aChild! !

!XAObjectInstanceGenerator methodsFor: 'instantiating' stamp: ' 6/23/2016 16:38:24'!
setXmiAttributesFrom: anElement to: anInstance
	"Other attributes such as xmi:uuid are not yet supported, and #xmi:idref is handled elsewhere."

	(anElement attributeAt: #xmi:id)
		ifNotEmpty: [ :id | anInstance instVarNamed: #xmiId put: id ]! !

!XAObjectInstanceGenerator methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
topInstance
	^ topInstance! !

Object subclass: #XADelayedClass
	instanceVariableNames: 'name parent package instanceVariables methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Utility'!

!XADelayedClass commentStamp: 'PeterUhnak 4/29/2016 11:12' prior: 0!
I am a delayed class generation object to save some time during the code generation process, because of this:

```
Something removeFromSystem.
[
	cls := Object subclass: #Something instanceVariableNames: 'someVar otherVar'
] timeToRun humanReadablePrintString. "'120 milliseconds'"

Something removeFromSystem.
[
	cls := Object subclass: #Something.
	cls addInstVarNamed: 'someVar'.
	cls addInstVarNamed: 'otherVar'.
] timeToRun humanReadablePrintString. "'1 second 492 milliseconds'"
```!

!XADelayedClass class methodsFor: 'as yet unclassified' stamp: ' 6/23/2016 16:38:24'!
name: aString parent: aClass package: aPkgName
	^ self new
		name: aString;
		parent: aClass;
		package: aPkgName;
		yourself! !

!XADelayedClass methodsFor: 'adding' stamp: ' 6/23/2016 16:38:24'!
addInstVarNamed: aString
	instanceVariables add: aString! !

!XADelayedClass methodsFor: 'generating' stamp: ' 6/23/2016 16:38:24'!
addMethod: aString classified: aProtocol to: aClass
	aClass compile: aString classified: aProtocol
	! !

!XADelayedClass methodsFor: 'adding' stamp: ' 6/23/2016 16:38:24'!
compile: aString classified: aProtocol
	| ast |
	ast := RBParser parseMethod: aString.
	methods at: ast selector put: aProtocol -> aString! !

!XADelayedClass methodsFor: 'testing' stamp: ' 6/23/2016 16:38:24'!
hasInstVarNamed: aString
	^ instanceVariables includes: aString! !

!XADelayedClass methodsFor: 'initialization' stamp: ' 6/23/2016 16:38:24'!
initialize
	super initialize.
	instanceVariables := Set new.
	methods := Dictionary new! !

!XADelayedClass methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
instVarNames
	^ self instanceVariables! !

!XADelayedClass methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
instanceVariables
	^ instanceVariables asArray! !

!XADelayedClass methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
name
	^ name! !

!XADelayedClass methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
name: aString
	name := aString! !

!XADelayedClass methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
package
	^ package! !

!XADelayedClass methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
package: aString
	package := aString! !

!XADelayedClass methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
parent
	^ parent! !

!XADelayedClass methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
parent: aClass
	parent := aClass! !

!XADelayedClass methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
realClass
	^ (Smalltalk hasClassNamed: self name)
		ifTrue: [ self name asClass ]
		ifFalse: [ nil ]! !

!XADelayedClass methodsFor: 'generating' stamp: ' 6/23/2016 16:38:24'!
save
	| cls |
	cls := self saveClass.
	methods do: [ :pair | self addMethod: pair value classified: pair key to: cls ].
	^ cls! !

!XADelayedClass methodsFor: 'generating' stamp: ' 6/23/2016 16:38:24'!
saveClass
	self assert: [ name isString & name isNotEmpty ].
	self assert: [ parent isClass ].
	self assert: [ instanceVariables isCollection ].
	self assert: [ instanceVariables allSatisfy: #isString ].
	self assert: [ package isString & package isNotEmpty ].
	^ parent
		subclass: name
		instanceVariableNames: (self instanceVariables joinUsing: ' ')
		classVariableNames: ''
		package: package! !

!XADelayedClass methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
selectors
	^ methods keys! !

Object subclass: #XATypeInference
	instanceVariableNames: 'visitor idRefs cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Core'!

!XATypeInference commentStamp: 'PeterUhnak 4/29/2016 14:27' prior: 0!
I provide a basic type inferencing for the XMI document.

Most importantly I analyze which attributes are IDREF and IDREFS, so the instantiator can create correct references.!

!XATypeInference methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
cacheAt: elementName
	^ cache at: elementName asSymbol ifAbsentPut: [ Dictionary new ]! !

!XATypeInference methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
cacheAt: elementName at: attributeKey
	^ (cache at: elementName asSymbol ifAbsentPut: [ Dictionary new ])
		at: attributeKey asSymbol
		ifAbsentPut: [ #EMPTY ]! !

!XATypeInference methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
cacheAt: elementName at: attributeKey put: aValue
	^ (cache at: elementName asSymbol ifAbsentPut: [ Dictionary new ])
		at: attributeKey asSymbol
		put: aValue! !

!XATypeInference methodsFor: 'as yet unclassified' stamp: ' 6/23/2016 16:38:24'!
castAttribute: anAttribute
	| type |
	type := self typeForAttribute: anAttribute.
	type = #Boolean
		ifTrue: [ ^ anAttribute value = 'true' ].
	type = #Number | (type = #Integer) | (type = #Float)
		ifTrue: [ ^ anAttribute value asNumber ].
	type = #IDREFS
		ifTrue: [ ^ anAttribute value
				ifEmpty: [ #() ]
				ifNotEmpty: [ (anAttribute value splitOn: ' ') asArray ] ].
	^ anAttribute value! !

!XATypeInference methodsFor: 'as yet unclassified' stamp: ' 6/23/2016 16:38:24'!
chooseBetween: oneType and: secondType
	| types |
	types := Set with: oneType with: secondType.
	types size = 1
		ifTrue: [ ^ types anyOne ].
	(types includes: #String)
		ifTrue: [ ^ #String ].
	(types includes: #EMPTY)
		ifTrue: [ ^ types detect: [ :each | (each = #EMPTY) not ] ].
	(types includes: #Integer)
		ifTrue: [ ^ types detect: [ :each | (each = #Integer) not ] ].
	(types includes: #IDREF) & (types includes: #IDREFS)
		ifTrue: [ ^ #IDREFS ].
	self error: 'Unhandled case'! !

!XATypeInference methodsFor: 'as yet unclassified' stamp: ' 6/23/2016 16:38:24'!
collectIdsFrom: aDocument
	^ ((aDocument allElements collect: [ :each | each attributeAt: #xmi:id ]) reject: #isEmpty) asSet! !

!XATypeInference methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
idRefs: aCollection
	idRefs := aCollection! !

!XATypeInference methodsFor: 'inference' stamp: ' 6/23/2016 16:38:24'!
inferAttribute: anAttribute
	| type previous newType |
	type := anAttribute name = #xmi:id
		ifTrue: [ #ID ]
		ifFalse: [ self inferValue: anAttribute value ].
	previous := self cacheAt: anAttribute element name at: anAttribute name.
	newType := self chooseBetween: type and: previous.
	self cacheAt: anAttribute element name at: anAttribute name put: newType.
	^ newType! !

!XATypeInference methodsFor: 'inference' stamp: 'HernanMoralesDurand 6/28/2017 19:55'!
inferDocument: aDocument
	idRefs := self collectIdsFrom: aDocument.
	(visitor := XATypeInferenceVisitor new) collector: self.
	visitor visitDocument: aDocument.
	^ cache! !

!XATypeInference methodsFor: 'inference' stamp: ' 6/23/2016 16:38:24'!
inferElement: anElement
	anElement attributeNodes do: [ :each | self inferAttribute: each ].
	^ self cacheAt: anElement name! !

!XATypeInference methodsFor: 'inference' stamp: ' 6/23/2016 16:38:24'!
inferValue: aString
	aString ifEmpty: [ ^ #EMPTY ].
	aString = 'true' | (aString = 'false')
		ifTrue: [ ^ #Boolean ].
	(NumberParser isNumber: aString)
		ifTrue: [ | num |
			num := NumberParser parse: aString.
			num isInteger
				ifTrue: [ ^ #Integer ].
			num isFloat
				ifTrue: [ ^ #Float ].
			^ #Number ].
	(idRefs includes: aString)
		ifTrue: [ ^ #IDREF ].
	((aString splitOn: ' ') allSatisfy: [ :each | idRefs includes: each ])
		ifTrue: [ ^ #IDREFS ].
	^ #String! !

!XATypeInference methodsFor: 'initialization' stamp: ' 6/23/2016 16:38:24'!
initialize
	super initialize.
	idRefs := Set new.
	cache := Dictionary new! !

!XATypeInference methodsFor: 'accessing' stamp: ' 6/23/2016 16:38:24'!
typeForAttribute: anAttribute
	^ self cacheAt: anAttribute element name at: anAttribute name! !

Object subclass: #XMIAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMI-Analyzer-Core'!

!XMIAnalyzer commentStamp: 'PeterUhnak 4/29/2016 16:07' prior: 0!
I am the entrypoint for XMI Analysis.

!!!! Examples

See class-side for examples.!

!XMIAnalyzer class methodsFor: 'public API' stamp: 'HernanMoralesDurand 6/28/2017 19:55'!
createClassesFor: aDom prefixed: aPrefix in: aPackage
	XACodeGeneratingVisitor new
		classPrefix: aPrefix;
		packageName: aPackage;
		visitDocument: aDom! !

!XMIAnalyzer class methodsFor: 'public API' stamp: 'HernanMoralesDurand 6/28/2017 19:55'!
createInstanceOf: aDom prefixed: aPrefix
	^ XAInstanceGeneratingVisitor new
		classPrefix: aPrefix;
		visitDocument: aDom! !

!XMIAnalyzer class methodsFor: 'examples' stamp: ' 6/23/2016 16:38:24'!
exampleStateMachineScenario
	^ (GTPlayground
		openContents:
			(((self class >> #sampleStateMachineScenario) sourceCode lines allButFirst: 2)
				joinUsing: String cr)
		label: 'Sample State Machine Scenario') window
		title: 'PL @ Sample State Machine Scenario'! !

!XMIAnalyzer class methodsFor: 'examples' stamp: ' 6/23/2016 16:38:24'!
sampleStateMachineScenario
|dom instance|
"dom := XMLDOMParser parse: FileLocator home asFileReference / 'prog/xmi/examples/smr2.xml'."
dom := XMIAnalyzer sampleStateMachineXmi.

"Generate the necessary classes. Prefix will be added before all generated classe."
XMIAnalyzer createClassesFor: dom prefixed: 'SMX' in: 'MyGeneratedClasses'.

"Create the instances in the generated classes."
instance := XMIAnalyzer createInstanceOf: dom prefixed: 'SMX'.

"Inspect the instance"
instance inspect.

"Apply a simple Mondrian demo visualization (requires Roassal)"
(XMIAnalyzer sampleStateMachineVisualization: instance) ifNotNil: #open.! !

!XMIAnalyzer class methodsFor: 'examples' stamp: ' 6/23/2016 16:38:24'!
sampleStateMachineVisualization: aModel
"a SMXModel"
| m fullName shape shapeLabel shapeNoText regionNest vertexNest smNest pkgNest modelNest |
	(Smalltalk hasClassNamed: #RTMondrian) ifFalse: [
		self inform: 'RTMondrian is not available. Install Roassal2 from the catalog.'.
		^ nil
	].
	m := RTMondrian new.
	fullName := [ :each | each name , '[' , (each className withoutPrefix: 'SMX') , ']' ].
	shape := [ :color | 
	m shape box
		color: color veryMuchLighter;
		borderColor: color;
		withTextAbove: [ :each | fullName value: each ];
		withTextColor: color ].
	shapeLabel := [ :color | 
	m shape label color: color.
	m interaction removeInteractionOfType: RTAbstractDraggable ].
	shapeNoText := [ :color | 
	m shape box
		color: color veryMuchLighter;
		borderColor: color ].
	vertexNest := [ :vertex | 
	shapeLabel value: Color black.
	m nodes: {(fullName value: vertex)}.
	shapeNoText value: Color blue.
	((vertex respondsTo: #region) and: [ vertex region isNotNil ])
		ifTrue: [ m nodes: vertex region forEach: regionNest.
			m layout verticalLine ] ].
	regionNest := [ :region | 
	shapeLabel value: Color blue.
	m nodes: {(fullName value: region)}.
	shapeNoText value: Color black.
	m nodes: (region subvertex ifNil: [ #() ]) forEach: vertexNest.
	m edges shape arrowedLine.
	m edges
		useAssociations:
			((region transition ifNil: [ #() ])
				collect: [ :each | each source -> each target ]).
	m layout horizontalTree ].
	smNest := [ :sm | 
	shapeNoText value: Color blue.
	m nodes: sm region forEach: regionNest ].
	pkgNest := [ :pkg | 
	shape value: Color black.
	m
		nodes: (pkg packagedElement select: [ :each | each isKindOf: #SMXStateMachine asClass ])
		forEach: smNest ].
	modelNest := [ :model | 
	shape value: Color green.
	m nodes: model packagedElement forEach: pkgNest ].
	shape value: Color red.
	m nodes: {aModel} forEach: modelNest.
	m build.
	m view @ RTZoomableView.
	^ m! !

!XMIAnalyzer class methodsFor: 'examples' stamp: ' 6/23/2016 16:38:24'!
sampleStateMachineXmi
	<script: 'self sampleStateMachineXmi inspect'>
	^ XMLDOMParser
		parse:
			'<?xml version="1.0" encoding="windows-1252"?>
<xmi:XMI xmi:version="2.1" xmlns:uml="http://schema.omg.org/spec/UML/2.1" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1" xmlns:thecustomprofile="http://www.sparxsystems.com/profiles/thecustomprofile/1.0">
	<xmi:Documentation exporter="Enterprise Architect" exporterVersion="6.5"/>
	<uml:Model xmi:type="uml:Model" name="EA_Model" visibility="public">
		<packagedElement xmi:type="uml:Package" xmi:id="ID_1" name="State Machine Model" visibility="public">
			<packagedElement xmi:type="uml:StateMachine" xmi:id="ID_2" name="EA_StateMachine1" visibility="public">
				<region xmi:type="uml:Region" xmi:id="ID_3" name="EA_Region1" visibility="public">
					<subvertex xmi:type="uml:State" xmi:id="ID_4" name="Composite Shape" visibility="public" isSubmachineState="false">
						<incoming xmi:idref="ID_5"/>
						<outgoing xmi:idref="ID_6"/>
						<region xmi:type="uml:Region" xmi:id="ID_7" name="up" visibility="public">
							<subvertex xmi:type="uml:State" xmi:id="ID_14" name="SubState Up" visibility="public" isSubmachineState="false">
								<incoming xmi:idref="ID_15"/>
								<outgoing xmi:idref="ID_16"/>
							</subvertex>
							<transition xmi:type="uml:Transition" xmi:id="ID_16" visibility="public" kind="local" source="ID_14" target="ID_17">
								<trigger xmi:idref="ID_18"/>
								<guard xmi:type="uml:Constraint" xmi:id="ID_19">
									<specification xmi:type="uml:OpaqueExpression" xmi:id="ID_20" body="someGuard"/>
								</guard>
							</transition>
							<transition xmi:type="uml:Transition" xmi:id="ID_15" visibility="public" kind="local" source="ID_24" target="ID_14"/>
							<subvertex xmi:type="uml:Pseudostate" xmi:id="ID_24" name="Initial Up" visibility="public" kind="initial">
								<outgoing xmi:idref="ID_15"/>
							</subvertex>
							<subvertex xmi:type="uml:State" xmi:id="ID_17" name="Substate Up 2" visibility="public" isSubmachineState="false">
								<incoming xmi:idref="ID_16"/>
								<outgoing xmi:idref="ID_21"/>
							</subvertex>
							<transition xmi:type="uml:Transition" xmi:id="ID_21" visibility="public" kind="local" source="ID_17" target="ID_22"/>
							<subvertex xmi:type="uml:FinalState" xmi:id="ID_22" name="Final Up" visibility="public">
								<incoming xmi:idref="ID_21"/>
							</subvertex>
						</region>
						<region xmi:type="uml:Region" xmi:id="ID_8" name="down" visibility="public">
							<subvertex xmi:type="uml:State" xmi:id="ID_10" name="SubState Down" visibility="public" isSubmachineState="false">
								<incoming xmi:idref="ID_11"/>
								<outgoing xmi:idref="ID_12"/>
							</subvertex>
							<transition xmi:type="uml:Transition" xmi:id="ID_12" visibility="public" kind="local" source="ID_10" target="ID_13"/>
							<subvertex xmi:type="uml:FinalState" xmi:id="ID_13" name="Final Down" visibility="public">
								<incoming xmi:idref="ID_12"/>
							</subvertex>
							<subvertex xmi:type="uml:Pseudostate" xmi:id="ID_23" name="Initial Down" visibility="public" kind="initial">
								<outgoing xmi:idref="ID_11"/>
							</subvertex>
							<transition xmi:type="uml:Transition" xmi:id="ID_11" visibility="public" kind="local" source="ID_23" target="ID_10"/>
						</region>
						<connectionPoint xmi:type="uml:Pseudostate" xmi:id="ID_25" name="EntryPoint1" visibility="public" kind="entryPoint"/>
					</subvertex>
					<transition xmi:type="uml:Transition" xmi:id="ID_6" visibility="public" kind="local" source="ID_4" target="ID_26"/>
					<subvertex xmi:type="uml:State" xmi:id="ID_27" name="Less" visibility="public" isSubmachineState="false">
						<incoming xmi:idref="ID_28"/>
						<outgoing xmi:idref="ID_29"/>
					</subvertex>
					<transition xmi:type="uml:Transition" xmi:id="ID_29" visibility="public" kind="local" source="ID_27" target="ID_30"/>
					<subvertex xmi:type="uml:State" xmi:id="ID_31" name="More" visibility="public" isSubmachineState="false">
						<incoming xmi:idref="ID_32"/>
						<outgoing xmi:idref="ID_33"/>
					</subvertex>
					<transition xmi:type="uml:Transition" xmi:id="ID_33" visibility="public" kind="local" source="ID_31" target="ID_30"/>
					<subvertex xmi:type="uml:Pseudostate" xmi:id="ID_26" name="Choice" visibility="public" kind="choice">
						<incoming xmi:idref="ID_6"/>
						<outgoing xmi:idref="ID_28"/>
						<outgoing xmi:idref="ID_32"/>
					</subvertex>
					<transition xmi:type="uml:Transition" xmi:id="ID_32" visibility="public" kind="local" source="ID_26" target="ID_31">
						<guard xmi:type="uml:Constraint" xmi:id="ID_47">
							<specification xmi:type="uml:OpaqueExpression" xmi:id="ID_48" body="x &gt;= 5"/>
						</guard>
					</transition>
					<transition xmi:type="uml:Transition" xmi:id="ID_28" visibility="public" kind="local" source="ID_26" target="ID_27">
						<guard xmi:type="uml:Constraint" xmi:id="ID_49">
							<specification xmi:type="uml:OpaqueExpression" xmi:id="ID_50" body="x &lt; 5"/>
						</guard>
					</transition>
					<subvertex xmi:type="uml:FinalState" xmi:id="ID_30" name="Final" visibility="public">
						<incoming xmi:idref="ID_29"/>
						<incoming xmi:idref="ID_33"/>
					</subvertex>
					<subvertex xmi:type="uml:Pseudostate" xmi:id="ID_51" name="Initial" visibility="public" kind="initial">
						<outgoing xmi:idref="ID_5"/>
					</subvertex>
					<transition xmi:type="uml:Transition" xmi:id="ID_5" visibility="public" kind="local" source="ID_51" target="ID_4"/>
				</region>
			</packagedElement>
			<packagedElement xmi:type="uml:Trigger" xmi:id="ID_18" name="trigger" visibility="public">
				<event xmi:type="uml:Event" xmi:id="ID_53"/>
			</packagedElement>
		</packagedElement>
	</uml:Model>
</xmi:XMI>'! !
